#include	<stdio.h>
#include	<string.h>
#include	<signal.h>
#include	<ctype.h>

#define	CHANGE	'\006'	/* ^F */
#define	NORMAL	'N'
#define	BOLD	'B'
#define	ULINE	'U'

#define	NEWPG	"## !! %% @@ && ** $$ ^ (( new page )) ^ $$ ** && @@ %% !! ##\n"

#define	ULCMD	"ul -t pslpr"

#define	CHFONT	"f"
#define	FNORMAL	"fn"
#define	FBOLD	"fb"
#define	FULINE	"fu"
#define	SHOW	"s"
#define	PAGE	"p"
#define	EOL	"l"
#define	END	"e"

extern char	*optarg;
extern int	optind, opterr;

char	*myname;
char	*ulcmd	= ULCMD;

main(argc, argv)
int	argc;
char	*argv[];
{
	int	c;
	FILE	*f;

	if ((myname = strrchr(argv[0], '/')) == NULL)
		myname = argv[0];
	else
		myname++;
	while ((c = getopt(argc, argv, "u:")) != EOF)
		switch (c)
		{
		case 'u':
			ulcmd = optarg;
			break;
		case '?':
			fprintf(stderr, "Usage: %s [ -u filter ] [ file ... ]\n", myname);
			exit(2);
		}
	if (optind == argc)
		dofile(stdin);
	else
		for (; optind < argc; optind++)
			if ((f = fopen(argv[optind], "r")) == NULL)
			{
				fprintf(stderr, "%s: ", myname);
				perror(argv[optind]);
			}
			else
			{
				dofile(f);
				fclose(f);
			}
	exit(0);
}

dofile(f1)
register FILE	*f1;
{
	register int	c;
	register FILE	*f2;
	int		fds[2][2];
	int		child;
	int		fd;
	int		instring;
	char		line[2048];
	register char	*s;

	if (pipe(fds[0]) == -1 || pipe(fds[1]) == -1)
	{
		fprintf(stderr, "%s: ", myname);
		perror("pipe");
		exit(1);
	}
	switch (child = fork())
	{
	case -1:
		fprintf(stderr, "%s: ", myname);
		perror("fork");
		exit(1);
	case 0:
		close(fds[0][1]);
		close(fds[1][0]);
		close(0);
		dup(fds[0][0]);
		close(fds[0][0]);
		close(1);
		dup(fds[1][1]);
		close(fds[1][1]);
		execl("/bin/sh", "sh", "-c", ulcmd, (char *)0);
		fprintf(stderr, "%s: ", myname);
		perror("execlp");
		exit(1);
	default:
		switch (child = fork())
		{
		case -1:
			fprintf(stderr, "%s: ", myname);
			perror("fork");
			exit(1);
			break;
		case 0:
			close(fds[0][0]);
			close(fds[0][1]);
			close(fds[1][1]);
			fd = dup(fds[1][0]);
			close(fds[1][0]);
			if ((f2 = fdopen(fd, "r")) == NULL)
			{
				fprintf(stderr, "%s: ", myname);
				perror("fdopen");
				kill(child, SIGTERM);
				exit(1);
			}
			instring = 0;
			printf("%s %s\n", FNORMAL, CHFONT);
			while ((s = fgets(line, sizeof line, f2)) != NULL)
			{
				if (strcmp(s, NEWPG) == 0)
				{
					if (instring)
					{
						instring = 0;
						printf(") %s\n", SHOW);
					}
					puts(PAGE);
					continue;
				}
				for ( ; *s; s++)
					switch (*s)
					{
					case CHANGE:
						if (instring)
						{
							instring = 0;
							printf(") %s\n", SHOW);
						}
						switch (*++s)
						{
						case NORMAL:
							printf("%s %s\n", FNORMAL, CHFONT);
							break;
						case BOLD:
							printf("%s %s\n", FBOLD, CHFONT);
							break;
						case ULINE:
							printf("%s %s\n", FULINE, CHFONT);
							break;
						case '\0':
							s--;
							break;
						default:
							putchar('\n');
							break;
						}
						break;
					case '\n':
						if (instring)
						{
							instring = 0;
							printf(") %s ", SHOW);
						}
						puts(EOL);
						break;
					default:
						if (!instring)
						{
							instring = 1;
							putchar('(');
						}
						switch (*s)
						{
						case '(':
						case ')':
						case '\\':
							putchar('\\');
							break;
						}
						putchar(*s);
					}
			}
			if (instring)
				printf(") %s\n", SHOW);
			puts(END);
			exit(0);
		default:
			close(fds[0][0]);
			close(fds[1][0]);
			close(fds[1][1]);
			fd = dup(fds[0][1]);
			close(fds[0][1]);
			if ((f2 = fdopen(fd, "w")) == NULL)
			{
				fprintf(stderr, "%s: ", myname);
				perror("fdopen");
				kill(child, SIGTERM);
				exit(1);
			}
			while ((c = fgetc(f1)) != EOF)
				if (c == '\f')
					fprintf(f2, "\n%s", NEWPG);
				else
					fputc(c, f2);
			fclose(f2);
			while (wait((int *)0) != -1)
				;
			return;
		}
	}
}
